# -*- encoding: utf-8 -*-
"""
 Created by eniocc at 11/10/2020
"""
import ctypes

from py_dss_interface.models import Bridge
from py_dss_interface.models.Base import Base
from typing import List


class ParallelV(Base):
    """
    This interface can be used to read/write certain properties of the active DSS object.

    The structure of the interface is as follows:
        void ParallelV(int32_t Parameter, VARIANT *Argument);

    This interface returns a Variant with the result of the query according to the value of the variable Parameter,
    which can be one of the following.
    """

    def _actor_progress(self) -> List[int]:
        return Bridge.pointer_read(self._dss_obj.ParallelV, 0)

    def _actor_status(self) -> List[int]:
        return Bridge.pointer_read(self._dss_obj.ParallelV, 1)
